"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePreload = usePreload;
exports.usePrefetch = usePrefetch;
exports.useKeepFresh = useKeepFresh;
exports.useAsync = useAsync;
exports.useAsyncAsset = useAsyncAsset;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = require("react");

var _reactEffect = require("@shopify/react-effect");

var _reactHooks = require("@shopify/react-hooks");

var _assets = require("./context/assets.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function usePreload() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var preloadable = args[0],
      _args$ = args[1],
      options = _args$ === void 0 ? {} : _args$;
  return preloadable.usePreload(options);
}

function usePrefetch() {
  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  var prefetchable = args[0],
      _args$2 = args[1],
      options = _args$2 === void 0 ? {} : _args$2;
  return prefetchable.usePrefetch(options);
}

function useKeepFresh() {
  for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    args[_key3] = arguments[_key3];
  }

  var keepFreshable = args[0],
      _args$3 = args[1],
      options = _args$3 === void 0 ? {} : _args$3;
  return keepFreshable.useKeepFresh(options);
}

function useAsync(resolver) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      assets = _ref.assets,
      _ref$scripts = _ref.scripts,
      scripts = _ref$scripts === void 0 ? assets : _ref$scripts,
      _ref$styles = _ref.styles,
      styles = _ref$styles === void 0 ? assets : _ref$styles,
      _ref$immediate = _ref.immediate,
      immediate = _ref$immediate === void 0 ? true : _ref$immediate;

  var _useState = (0, _react.useState)(function () {
    return immediate || typeof window !== 'undefined' ? resolver.resolved : null;
  }),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var mounted = (0, _reactHooks.useMountedRef)();
  var load = (0, _react.useCallback)( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var resolved;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(value != null)) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", value);

          case 2:
            _context.prev = 2;
            _context.next = 5;
            return resolver.resolve();

          case 5:
            resolved = _context.sent;

            if (mounted.current) {
              // It's important to use the function form of setValue here.
              // Resolved is going to be a function in most cases, since it's
              // a React component. If you do not set it using the function form,
              // React treats the component as the function that returns state,
              // so it sets state with the result of manually calling the component
              // (so, usually JSX).
              setValue(function () {
                return resolved;
              });
            }

            return _context.abrupt("return", resolved);

          case 10:
            _context.prev = 10;
            _context.t0 = _context["catch"](2);

            if (mounted.current) {
              setValue(_context.t0);
            }

            return _context.abrupt("return", _context.t0);

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 10]]);
  })), [mounted, resolver, value]);
  var id = resolver.id;
  useAsyncAsset(id, {
    scripts: scripts,
    styles: styles
  });
  return value instanceof Error ? {
    id: id,
    resolved: null,
    error: value,
    loading: false,
    load: load
  } : {
    id: id,
    resolved: value,
    error: null,
    loading: value == null,
    load: load
  };
}

function useAsyncAsset(id) {
  var _ref3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      scripts = _ref3.scripts,
      styles = _ref3.styles;

  var async = (0, _react.useContext)(_assets.AsyncAssetContext);
  (0, _reactEffect.useServerEffect)(function () {
    if (async && id) {
      async.markAsUsed(id, {
        scripts: scripts,
        styles: styles
      });
    }
  }, async === null || async === void 0 ? void 0 : async.effect);
}